forked from gouthampradhan/leetcode
-
Notifications
You must be signed in to change notification settings - Fork 0
/
Copy pathCombinationSumIV.java
66 lines (54 loc) · 1.51 KB
/
CombinationSumIV.java
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
package dynamic_programming;
import java.util.Arrays;
/**
* Created by gouthamvidyapradhan on 17/12/2017.
* Given an integer array with all positive numbers and no duplicates, find the number of possible combinations that
* add up to a positive integer target.
Example:
nums = [1, 2, 3]
target = 4
The possible combination ways are:
(1, 1, 1, 1)
(1, 1, 2)
(1, 2, 1)
(1, 3)
(2, 1, 1)
(2, 2)
(3, 1)
Note that different sequences are counted as different combinations.
Therefore the output is 7.
Follow up:
What if negative numbers are allowed in the given array?
How does it change the problem?
What limitation we need to add to the question to allow negative numbers?
Solution: Backtrack and dp
*/
public class CombinationSumIV {
/**
* Main method
* @param args
* @throws Exception
*/
public static void main(String[] args) throws Exception{
int[] A = {1, 2, 3};
System.out.println(new CombinationSumIV().combinationSum4(A, 4));
}
public int combinationSum4(int[] nums, int target) {
int[] dp = new int[target + 1];
Arrays.fill(dp, -1);
dp[0] = 1;
return backtrack(nums, dp, target);
}
private int backtrack(int[] nums, int[] dp, int sum){
int total = 0;
if(sum < 0) return 0;
if(dp[sum] != -1) return dp[sum];
else{
for (int num : nums) {
total += backtrack(nums, dp, sum - num);
}
}
dp[sum] = total;
return dp[sum];
}
}